=== modified file 'bzr-handle-patch'
--- bzr-handle-patch	2012-02-03 21:57:56 +0000
+++ bzr-handle-patch	2012-02-03 22:55:40 +0000
@@ -36,4 +36,8 @@
 	from bzrlib.plugins.gtk.dialog import error_dialog
 	error_dialog('Error', str(e))
 	raise
+
+if len(sys.argv) == 3 and sys.argv[2] == 'test':
+    sys.exit(0)
+
 Gtk.main()

=== modified file 'tests/test_commit.py'
--- tests/test_commit.py	2012-01-23 16:52:40 +0000
+++ tests/test_commit.py	2012-02-03 22:55:40 +0000
@@ -17,6 +17,8 @@
 """Test the Commit functionality."""
 
 import os
+import subprocess
+from tempfile import NamedTemporaryFile
 
 from gi.repository import Gtk
 
@@ -1296,3 +1298,32 @@
         self.assertEquals(u'', self._get_commit_message())
         self.assertEquals(u'de',
                           self._get_file_commit_messages())
+
+
+class BzrHandlePatchTestCase(tests.TestCase):
+
+    def setUp(self):
+        top = os.path.abspath(os.path.join(
+            os.path.dirname(__file__), os.pardir))
+        self.script = os.path.join(top, 'bzr-handle-patch')
+        self.env = dict(os.environ)
+        self.env['BZR_PLUGINS_AT'] = 'gtk@%s' %top
+        self.patch = NamedTemporaryFile()
+        self.patch.write('\n'.join([
+            "=== added file '_test.txt'",
+            "--- _test.txt	1970-01-01 00:00:00 +0000",
+            "+++ _test.txt	2012-02-03 20:00:34 +0000",
+            "@@ -0,0 +1,1 @@",
+            "+hello",
+            ]))
+        self.patch.flush()
+        super(BzrHandlePatchTestCase, self).setUp()
+
+    def test_smoketest(self):
+        # This is a smoke test to verify the process starts.
+        bzr_notify = subprocess.Popen(
+            [self.script, self.patch.name, 'test'],
+            stdout=subprocess.PIPE, stderr=subprocess.PIPE, env=self.env)
+        stdout, stderr = bzr_notify.communicate()
+        self.assertEqual('', stdout)
+        self.assertEqual('', stderr)

